// tarpinis (intermediate) kodas. ji sugeneruoja ish sintakses medzhio.
// tada dar (gal) paoptimizuoja ir sprauniai pavercia i bytekoda.

#ifndef __INTERCODE__
#define __INTERCODE__

#include "opcodes.h"

// tarpinio kodo instrukcija
struct TIntInsn {
public:
        TIntInsn();
        TIntInsn(EIntOpcode o); // NOP
        TIntInsn(EIntOpcode o, TIntInsn *t); // JMP,JZ,JT
        TIntInsn(EIntOpcode o, long c, long i = 0);
        TIntInsn(EIntOpcode o, float f);
        void show();
        TIntInsn *optimize(); // susioptimizuoja
        TIntInsn *get(long);
//private: // aj, bet ne...
        EIntOpcode op;  // opkodas
        short count;    // su kiek baitu daryti
        union {
                long       vali;
                float      valf;
                TIntInsn  *target;
        };
        TIntInsn *next;
        long num;
// reikia
        static const char *names[];
        static const long isCount[];
private:
        static long __num;
        void __fill();
};

inline void TIntInsn::__fill()
{
        count = 0;
        vali = 0;
        next = NULL;
        num = __num++;
}
inline TIntInsn::TIntInsn()
        { __fill(); op = IOP_NOP; }
inline TIntInsn::TIntInsn(EIntOpcode o)
        { __fill(); op = o; }
inline TIntInsn::TIntInsn(EIntOpcode o, TIntInsn *t)
        { __fill(); op = o; target = t; }
inline TIntInsn::TIntInsn(EIntOpcode o, long c, long i)
        { __fill(); op = o; count = c; vali = i; }
inline TIntInsn::TIntInsn(EIntOpcode o, float f)
        { __fill(); op = o; valf = f; }

#endif

