// visu TNode::debug() funkcijos

#include <iostream>

#include "syntree.h"
#include "utils.h"

using namespace std;

static void debid(long i)
	{ for (long ii = 0; ii < i; ii++) cout<<"   "; };
#define DEBID() { debid(n); }

/** abstraktus *************************************************************/
void TNode::debug(long n) const
		{ DEBID(); cout<<strDebNode<<endl; }
void TEmptyNode::debug(long n) const
		{ DEBID(); cout<<strDebEmpty<<endl; }
void TListNode::debug(long n) const
{
		node->debug(n);
		list->debug(n);
}
/** sakiniai ***************************************************************/
void TCondStatNode::debug(long n) const
{
		DEBID(); cout<<strDebCond<<endl;
		cond->debug(n+1);
		DEBID(); cout<<strDebStat<<endl;
		stat->debug(n+1);
}
void TIfNode::debug(long n) const
{
		DEBID(); cout<<"IF\n";
		TCondStatNode::debug(n+1);
}
void TIfElseNode::debug(long n) const
{
		DEBID(); cout<<"IF + ELSE\n";
		TCondStatNode::debug(++n);
		DEBID(); cout<<"ELSE\n";
		stat2->debug(n+1);
}
void TTernaryNode::debug(long n) const
{
		DEBID(); cout<<"A?B:C ternop\n";
		TCondStatNode::debug(++n);
		DEBID(); cout<<"else\n";
		stat2->debug(n+1);
}
void TWhileNode::debug(long n) const
{
		DEBID(); cout<<"WHILE\n";
		TCondStatNode::debug(n+1);
}
void TDoNode::debug(long n) const
{
		DEBID(); cout<<"DO + UNTIL\n";
		TCondStatNode::debug(n+1);
}
void TForNode::debug(long n) const
{
		DEBID(); cout<<"FOR\n";
		n++;
		DEBID(); cout<<strDebInit<<endl;
		init->debug(n+1);
		DEBID(); cout<<strDebCond<<endl;
		cond->debug(n+1);
		DEBID(); cout<<strDebLoop<<endl;
		loop->debug(n+1);
		DEBID(); cout<<strDebStat<<endl;
		stat->debug(n+1);
}
void TReturnNode::debug(long n) const
		{ DEBID(); cout<<"RETURN\n"; }
void TDeleteNode::debug(long n) const
		{ DEBID(); cout<<"DELETE\n"; lval->debug(n+1); }
/** binarines, unarines, priskyrimo op. ************************************/
void TBinaryNode::debug(long n) const
{
		DEBID(); cout<<"binop "<<p->name<<endl;
		n++;
		op1->debug(n);
		op2->debug(n);
}
void TUnaryNode::debug(long n) const
{
		DEBID(); cout<<"unop "<<p->name<<endl;
		n++;
		op->debug(n);
}
void TAssignNode::debug(long n) const
{
		DEBID(); cout<<"asop =\n";
		n++;
		lval->debug(n);
		expr->debug(n);
}
void TAsArithNode::debug(long n) const
{
		DEBID(); cout<<"asop "<<p->name<<endl;
		n++;
		lval->debug(n);
		expr->debug(n);
}
/** f-ju kvietimas *********************************************************/
void TFuncNode::debug(long n) const
{
		DEBID(); cout<<"CALL "<<func->getName();
		if (super >= 0) cout <<" SUPER";
		cout << endl;
		n++;
		DEBID(); cout<<strDebObj<<endl;
		lval->debug(n+1);
		DEBID(); cout<<strDebArgs<<endl;
		TArgs *a = args;
		while (a) {
				a->expr->debug(n+1);
				a = a->next;
		}
}
void TNativeNode::debug(long n) const
		{ DEBID(); cout<<"NATIVE "<<slot<<'\n'; }

/** multi-expr *********************************************************/
void TMultiExprNode::debug(long n) const
{
	DEBID(); cout<<"MULTI-EXPR"<<endl;
	n++;
	DEBID(); cout<<strDebArgs<<endl;
	TArgs *a = exprs;
	while (a) {
		a->expr->debug(n+1);
		a = a->next;
	}
}

/** konversijos ************************************************************/

void T2Float::debug(long n) const
		{ DEBID(); cout<<"op (float)\n"; op->debug(n+1); }
void T2Long::debug(long n) const
		{ DEBID(); cout<<"op (long)\n"; op->debug(n+1); }
/** lval *******************************************************************/
void TOffsetNode::debug(long n) const
{
		DEBID(); cout<<"offset [type "<<lval->type()->getName()<<"]\n";
		lval->debug(n+1);
		expr->debug(n+1);
}
void TMemberNode::debug(long n) const
{
		DEBID(); cout<<"MEMBER "<<sym->getName()<<" (ofs="<<sym->Offset()<<")\n";
		lval->debug(n+1);
}
void TBaseRefNode::debug(long n) const
{
		DEBID();
		switch (mode) {
		case E_THIS   : cout<<"this\n";   break;
		case E_FRAME  : cout<<"local\n";  break;
		case E_STATIC : cout<<"static\n"; break;
		}
}
void TNewNode::debug(long n) const
	{ DEBID(); cout<<"NEW "<<cla->Name()<<'\n'; }
void TIsNode::debug(long n) const
{
		DEBID(); cout<<"INSTANCEOF "<<cla->Name()<<'\n';
		lval->debug(n+1);
}
/** terminatoriai **********************************************************/
void TStringNode::debug(long n) const
	{ DEBID(); cout<<"string  ("<<offset<<")\n"; }
void TNumberNode::debug(long n) const
	{ DEBID(); cout<<(long)val<<'\n'; }
void TFloatNode::debug(long n) const
	{ DEBID(); cout<<val<<'\n'; }
void TIdentNode::debug(long n) const
	{ DEBID(); cout<<"IDENT\n"; lval->debug(n+1); }

