// CString eiluciu klase. maza, be featuru, uztad ne STL string monstras.
// NeARAZ, 2000 09 25
// reikia <cstring> ir <iostream>

#ifndef __CString_H__
#define __CString_H__

class CString {
		char *s;
		long  sz;
		void init(long nsz, const char *ns);
		void assign(long nsz, const char *ns);
		CString(long nsz, char *ns);
public:
		// konstr/destr
		CString()
			{ init(0, ""); };
		CString(const char *ns)
			{ init(strlen(ns), ns); };
		CString(const CString& ns)
			{ init(ns.sz, ns.s); };
		~CString()
			{ delete[] s; };
		// priskyrimas ir sudetis
		CString& operator= (const char *ns)
			{ assign(strlen(ns), ns); return *this; };
		CString& operator= (const CString& ns)
			{ assign(ns.sz, ns.s); return *this; };
		CString& operator+= (const CString&);
		CString& operator+= (const char*);
		CString& operator+= (char);
		friend CString operator+ (const CString& a, const CString& b);
		friend CString operator+ (const CString& a, const char *b);
		friend CString operator+ (const CString& a, char b);
		// kiti
		void erase(long i);
		long hashCode() const; // grazina hashkoda 0..65535
		// indeksacija
		char operator[] (long i)
			{ return s[i]; };
		// dydis ir C eil.
		long size() const
			{ return sz; };
		const char *c_str() const
			{ return s; };
		// lyginimas
		friend bool operator== (const CString& a, const char *b)
			{ return strcmp(a.s, b) == 0; };
		friend bool operator== (const CString& a, const CString& b)
			{ return strcmp(a.s, b.s) == 0; };
		friend bool operator!= (const CString& a, const char *b)
			{ return strcmp(a.s, b) != 0; };
		friend bool operator!= (const CString& a, const CString& b)
			{ return strcmp(a.s, b.s) != 0; };
		// isvedimas
		friend std::ostream& operator<< (std::ostream& o, const CString& s)
			{ o<<s.s; return o; };
};

#endif


